## Index

### Modules

- "hdkey"

### Classes

- Account
- Accounts
- BatchManager
- CS
- ChainStack
- ConnectionTimeoutError
- Contract
- Core
- DecryptAccountsError
- HttpProvider
- InvalidAddressError
- InvalidCallbackError
- InvalidConnectionError
- InvalidContractAddressError
- InvalidContractOptionsError
- InvalidHexStringError
- InvalidMethodParamsError
- InvalidMnemonicError
- InvalidNumberError
- InvalidNumberOfParamsError
- InvalidPasswordError
- InvalidPrivateKeyError
- InvalidPrivateKeyNumError
- InvalidProviderError
- InvalidProviderPathError
- InvalidRequestManagerError
- InvalidResponseError
- IpcProvider
- JsonRpc
- KeyDerivationError
- Method
- Net
- NoInvalidPrivateExtendedKeyError
- NoInvalidPrivateKeyError
- OutOfRangeError
- Personal
- PromiseWithEvent
- RequestManager
- ResponseError
- Subscription
- Subscriptions
- ToBigNumberError
- Transaction
- UnsupportedCipherError
- UnsupportedKdfError
- UnsupportedParamsToPBKDF2Error
- UnsupportedSubscriptionsProviderError
- Wallet
- WebsocketProvider
- WrongMethodForParams
- WrongResponseIdError

### Interfaces

- AccountBalanceOutput
- AccountObject
- ContractData
- ContractOptions
- ContractOutput
- ContractParams
- ContractResult
- DecodeResultInterface
- EncryptOptions
- EncryptResult
- HDAccountConfig
- HeaderConfig
- MethodOptions
- Payload
- PayloadObject
- ProvidersInterface
- SignResult
- SignedTransactionResult
- SubscriptionOptions
- TransactionData
- TransactionInput
- TransactionResult
- WalletAccountObject
- Witness

### Type aliases

- PromiEventInterface
- Provider

### Variables

- ADDRESS_PREFIX
- ADD_TO_VALUE
- CONTRACT_ADDRESS_PREFIX_ERC20
- CONTRACT_TYPE_ERC20
- EXTENDED_KEY_LENGTH
- SEED_LENGTHS
- SHA3_NULL_S
- add
- div
- isBN
- mock
- mul
- pk1
- pk2
- sign
- sub
- testData
- webSocket

### Functions

- PromiEvent
- at
- bin
- checkAddressChecksum
- compressToUncompressPublicKey
- concat
- dataTree
- dechunk
- decode
- decodeSignature
- encode
- encodeSignature
- fireError
- flatten
- formatNumberToHex
- formatUtf8ToHex
- fromArray
- fromAscii
- fromBN
- fromNat
- fromNumber
- fromPrivate
- fromPublic
- fromString
- fromUint8Array
- fromUnit
- genContractAddress
- getAddressPrefix
- getChainId
- getTransactionFromRaw
- getTransactionId
- getUnit
- hashRlpTx
- hexToBase64
- hexToBuffer
- hexToBytes
- hexToNumber
- hexToNumberString
- hexToUtf8
- inputAddressFormatter
- inputAddressesFormatter
- inputContractCallFormatter
- inputHashFormatter
- inputPlaceholderFormatter
- isAddress
- isContractAddress
- isHex
- isHexStrict
- keccak256
- keccak512
- length
- makeSigner
- noop
- numberToHex
- outputBalanceFormatter
- outputContractDetailFormatter
- outputNonceFormatter
- pad
- padEven
- padRight
- parseFromHex
- parseHex
- parseLength
- parseList
- parseListLength
- parseTree
- privateToPublicKey
- recover
- reverse
- rlpSignedTx
- rlpTx
- sha3
- signTransaction
- slice
- toArray
- toAscii
- toBN
- toChecksum
- toChecksumAddress
- toNat
- toNumber
- toString
- toUint256
- toUint8Array
- toUnit
- uint
- utf8ToHex

### Object literals

- provider
- transactionResult
- transactionResult2
- unitMap

## Type aliases

### PromiEventInterface

PromiEventInterface: object & function

- Defined in core/promiEvent/index.ts:29

### Provider

Provider: HttpProvider | IpcProvider | WebsocketProvider

- Defined in providers/index.ts:8

## Variables

### Const ADDRESS_PREFIX

ADDRESS_PREFIX: "0000" = "0000"

- Defined in helper/account.ts:8

### Const ADD_TO_VALUE

ADD_TO_VALUE: 54 = 54

- Defined in helper/transaction.ts:8

### Const CONTRACT_ADDRESS_PREFIX_ERC20

CONTRACT_ADDRESS_PREFIX_ERC20: "0001" = "0001"

- Defined in utils/utils.ts:131
- Defined in helper/account.ts:9

### Const CONTRACT_TYPE_ERC20

CONTRACT_TYPE_ERC20: "ERC20" = "ERC20"

- Defined in helper/account.ts:11
- Defined in cs/contract/index.ts:6

### Const EXTENDED_KEY_LENGTH

EXTENDED_KEY_LENGTH: 111 = 111

- Defined in cs/accounts/index.ts:10

### Const SEED_LENGTHS

SEED_LENGTHS: number[] = [128, 256, 512]

- Defined in cs/accounts/index.ts:11

### Const SHA3_NULL_S

SHA3_NULL_S: "0xc5d2460186f7233c927e7db2dcc703c0e500b653ca82273b7bfad8045d85a470" = "0xc5d2460186f7233c927e7db2dcc703c0e500b653ca82273b7bfad8045d85a470"

- Defined in utils/utils.ts:47

### Const add

add: function = bin('add')

- Defined in helper/nat.ts:36

#### Type declaration

- - (a: string, b: string): string

  - #### Parameters

    - ##### a: string

    - ##### b: string

    #### Returns string

### Const div

div: function = bin('div')

- Defined in helper/nat.ts:38

#### Type declaration

- - (a: string, b: string): string

  - #### Parameters

    - ##### a: string

    - ##### b: string

    #### Returns string

### Const isBN

isBN: isBigNumber = BN.isBigNumber

- Defined in utils/utils.ts:15

Returns true if object is BN, otherwise false

method

  isBN

param
returns

### Const mock

mock: MockAdapter = new MockAdapter(axios)

- Defined in providers/httpProvider.spec.ts:6

### Const mul

mul: function = bin('mul')

- Defined in helper/nat.ts:37

#### Type declaration

- - (a: string, b: string): string

  - #### Parameters

    - ##### a: string

    - ##### b: string

    #### Returns string

### Const pk1

pk1: "0x289c2857d4598e37fb9647507e47a309d6133539bf21a8b9cb6df88fd5232031" = "0x289c2857d4598e37fb9647507e47a309d6133539bf21a8b9cb6df88fd5232031"

- Defined in cs/transaction/index.spec.ts:4
- Defined in helper/transaction.spec.ts:3

### Const pk2

pk2: "0x289c2857d4598e37fb9647507e47a309d6133539bf21a8b9cb6df88fd5232032" = "0x289c2857d4598e37fb9647507e47a309d6133539bf21a8b9cb6df88fd5232032"

- Defined in cs/transaction/index.spec.ts:5
- Defined in helper/transaction.spec.ts:4

### Const sign

sign: (Anonymous function) = makeSigner(0)

- Defined in helper/account.ts:157

### Const sub

sub: function = bin('sub')

- Defined in helper/nat.ts:39

#### Type declaration

- - (a: string, b: string): string

  - #### Parameters

    - ##### a: string

    - ##### b: string

    #### Returns string

### Const testData

testData: object[] = [{address: '0x0000eb014f8c8b418DB6B45774C326A0e64C78914dc0',data: 'Some data',hash: '0x3b9d51379da4f56cb55ca3e7f7ca92c8798b1d25abe0d6a6abab50b135e7794e',privateKey:'0xbe6383dad004f233317e46ddb46ad31b16064d14447a95cc1d8c8d4bc61c3728',r: '0x123476d36992bdef82362488eb00a154b52284cc0ccec330227f6d3b2b8d763d',s: '0x6d9e18d574a01d519024b91e4193d43fd94e806bc6b0c35941e36dd0a79f0b97',signature:'0x123476d36992bdef82362488eb00a154b52284cc0ccec330227f6d3b2b8d763d6d9e18d574a01d519024b91e4193d43fd94e806bc6b0c35941e36dd0a79f0b971',v: '0x1'},{address: '0x0000eb014f8c8b418DB6B45774C326A0e64C78914dc0',data: 'Some data!%$$%&@*',hash: '0x27e5ac66bbdd0cf0e1c79b01d8c9fa922f231be88571a1f0daf1368e29e4c8f4',privateKey:'0xbe6383dad004f233317e46ddb46ad31b16064d14447a95cc1d8c8d4bc61c3728',r: '0x1c5b5023cb202ce23deb6af76643b649bd925b8c01f5bcd77cfd3ac64a42e255',s: '0x1cc30ae3e43a43bf5007b072bea2382dddcb6c42ff9148167e4dbdf98d81705d',signature:'0x1c5b5023cb202ce23deb6af76643b649bd925b8c01f5bcd77cfd3ac64a42e2551cc30ae3e43a43bf5007b072bea2382dddcb6c42ff9148167e4dbdf98d81705d1',v: '0x1'},{address: '0x0000eb014f8c8b418DB6B45774C326A0e64C78914dc0',data: '0xc5d2460186f7233c927e7db2dcc703c0e500b653ca82273b7bfad8045d85a470',hash: '0x23fe140efd3b576f9ce2da8b74152c2f52fee46a03224dbd065133ed564ab2c9',privateKey:'0xbe6383dad004f233317e46ddb46ad31b16064d14447a95cc1d8c8d4bc61c3728',// signature done with personal_signr: '0x93df68f0cc6b00db0fb397fac0ffad63e95810c7cad6f2fd262ba7ed5ee2a325',s: '0x37b239e7675f328650a9beacbc9465d56625b607e462ffefd7f63039abc46a7b',signature:'0x93df68f0cc6b00db0fb397fac0ffad63e95810c7cad6f2fd262ba7ed5ee2a32537b239e7675f328650a9beacbc9465d56625b607e462ffefd7f63039abc46a7b1',v: '0x1'}]

- Defined in cs/accounts/index.spec.ts:96

### Const webSocket

webSocket: w3cwebsocket = WebSocket.w3cwebsocket

- Defined in providers/wsProvider.ts:6

## Functions

### Const PromiEvent

- PromiEvent(justPromise?: boolean): PromiseWithEvent

- - Defined in core/promiEvent/index.ts:33

  #### Parameters

  - ##### Optional justPromise: boolean

  #### Returns PromiseWithEvent

### Const at

- at(bytes: string, index: number): number

- - Defined in helper/bytes.ts:7

  Get the byte at the specified position in bytes

  #### Parameters

  - ##### bytes: string

  - ##### index: number

  #### Returns number

### Const bin

- bin(method: string): function

- - Defined in helper/nat.ts:31

  #### Parameters

  - ##### method: string

  #### Returns function

  - - (a: string, b: string): string

    - #### Parameters

      - ##### a: string

      - ##### b: string

      #### Returns string

### Const checkAddressChecksum

- checkAddressChecksum(addrs: string): boolean

- - Defined in utils/utils.ts:159

  Checks if the given string is a checksummed address

  #### Parameters

  - ##### addrs: string

  #### Returns boolean

### Const compressToUncompressPublicKey

- compressToUncompressPublicKey(publicKey: string): string

- - Defined in helper/account.ts:102

  Transfrom a compressed public key to uncompressed public key

  #### Parameters

  - ##### publicKey: string

    Compressed key

  #### Returns string

  Uncompressed key

### Const concat

- concat(a: string, b: string): string

- - Defined in helper/bytes.ts:121

  concat two bytes string

  #### Parameters

  - ##### a: string

  - ##### b: string

  #### Returns string

### Const dataTree

- dataTree(tree: string | any[]): string

- - Defined in helper/rlp.ts:25

  #### Parameters

  - ##### tree: string | any[]

  #### Returns string

### Const dechunk

- dechunk(data: string): string

- - Defined in utils/utils.ts:322

  #### Parameters

  - ##### data: string

  #### Returns string

### Const decode

- decode(hex: string): string | any[]

- - Defined in helper/rlp.ts:109

  #### Parameters

  - ##### hex: string

  #### Returns string | any[]

### Const decodeSignature

- decodeSignature(hex: string): string[]

- - Defined in helper/account.ts:124

  Decode signature string to r s v

  #### Parameters

  - ##### hex: string

  #### Returns string[]

### Const encode

- encode(tree: string | any[]): string

- - Defined in helper/rlp.ts:38

  #### Parameters

  - ##### tree: string | any[]

  #### Returns string

### Const encodeSignature

- encodeSignature(__namedParameters: [string, string, string]): string

- - Defined in helper/account.ts:115

  Encode signature r s v to signature string

  #### Parameters

  - ##### __namedParameters: [string, string, string]

  #### Returns string

  signature string

### Const fireError

- fireError(error: any, emitter: any, reject: any, callback: any): any

- - Defined in utils/index.ts:34

  #### Parameters

  - ##### error: any

  - ##### emitter: any

  - ##### reject: any

  - ##### callback: any

  #### Returns any

### Const flatten

- flatten(bytesArray: string[]): string

- - Defined in helper/bytes.ts:23

  Transfrom bytes array to bytes string

  #### Parameters

  - ##### bytesArray: string[]

  #### Returns string

### Const formatNumberToHex

- formatNumberToHex(value: number | string): string

- - Defined in utils/utils.ts:334

  encode format utils

  #### Parameters

  - ##### value: number | string

  #### Returns string

### Const formatUtf8ToHex

- formatUtf8ToHex(value: string): string

- - Defined in utils/utils.ts:340

  #### Parameters

  - ##### value: string

  #### Returns string

### Const fromArray

- fromArray(arr: number[]): string

- - Defined in helper/bytes.ts:82

  Return bytes from number array

  #### Parameters

  - ##### arr: number[]

  #### Returns string

### Const fromAscii

- fromAscii(ascii: string): string

- - Defined in helper/bytes.ts:137

  From ASCII to bytes string

  #### Parameters

  - ##### ascii: string

  #### Returns string

### Const fromBN

- fromBN(bn: BN): string

- - Defined in helper/nat.ts:4

  #### Parameters

  - ##### bn: BN

  #### Returns string

### Const fromNat

- fromNat(bn: string): string

- - Defined in helper/bytes.ts:123

  #### Parameters

  - ##### bn: string

  #### Returns string

### Const fromNumber

- fromNumber(num: number): string
- fromNumber(a: string | number): string

- - Defined in helper/bytes.ts:105

  Return bytes string from number

  #### Parameters

  - ##### num: number

  #### Returns string

- - Defined in helper/nat.ts:20

  Return bytes string from number

  #### Parameters

  - ##### a: string | number

  #### Returns string

### Const fromPrivate

- fromPrivate(privateKey: string, type?: string): string

- - Defined in helper/account.ts:58

  Returns the check sum address of a given private key

  #### Parameters

  - ##### privateKey: string

    A private key must be 256 bits wide

  - ##### Optional type: string

  #### Returns string

  Address

### Const fromPublic

- fromPublic(publicKey: string, type?: string): string

- - Defined in helper/account.ts:71

  Returns the check sum address of a given public key

  #### Parameters

  - ##### publicKey: string

    The two points of an uncompressed key or one point of an compressed key

  - ##### Optional type: string

  #### Returns string

  Address

### Const fromString

- fromString(s: string): string
- fromString(str: string): string

- - Defined in helper/bytes.ts:165

  Return bytes string from string

  #### Parameters

  - ##### s: string

  #### Returns string

- - Defined in helper/nat.ts:8

  Return bytes string from string

  #### Parameters

  - ##### str: string

  #### Returns string

### Const fromUint8Array

- fromUint8Array(arr: Uint8Array): string

- - Defined in helper/bytes.ts:98

  Return bytes string from Uint8Array

  #### Parameters

  - ##### arr: Uint8Array

  #### Returns string

### Const fromUnit

- fromUnit(num: string | number | BN, unitType?: string): string

- - Defined in utils/index.ts:115

  #### Parameters

  - ##### num: string | number | BN

  - ##### Optional unitType: string

  #### Returns string

### Const genContractAddress

- genContractAddress(): string

- - Defined in helper/account.ts:41

  #### Returns string

### Const getAddressPrefix

- getAddressPrefix(type: string): string

- - Defined in helper/account.ts:16

  #### Parameters

  - ##### type: string

  #### Returns string

### Const getChainId

- getChainId(v: string): string

- - Defined in helper/transaction.ts:28

  #### Parameters

  - ##### v: string

  #### Returns string

### Const getTransactionFromRaw

- getTransactionFromRaw(raw: string): TransactionResult

- - Defined in helper/transaction.ts:68

  #### Parameters

  - ##### raw: string

  #### Returns TransactionResult

### Const getTransactionId

- getTransactionId(transactionData: TransactionData): string

- - Defined in helper/transaction.ts:93

  #### Parameters

  - ##### transactionData: TransactionData

  #### Returns string

### Const getUnit

- getUnit(unitType: string): string

- - Defined in utils/index.ts:111

  #### Parameters

  - ##### unitType: string

  #### Returns string

### Const hashRlpTx

- hashRlpTx(tx: any): string

- - Defined in helper/transaction.ts:31

  #### Parameters

  - ##### tx: any

  #### Returns string

### Const hexToBase64

- hexToBase64(hex: string): string

- - Defined in utils/utils.ts:295

  Should be called to get base64 from it's hex representation

  #### Parameters

  - ##### hex: string

  #### Returns string

### Const hexToBuffer

- hexToBuffer(hex: string | Buffer): Buffer

- - Defined in utils/utils.ts:318

  Converts hex to Buffer

  #### Parameters

  - ##### hex: string | Buffer

  #### Returns Buffer

### Const hexToBytes

- hexToBytes(hex: any): any[]

- - Defined in utils/utils.ts:94

  Convert a hex string to a byte array

  Note: Implementation from crypto-js

  #### Parameters

  - ##### hex: any

  #### Returns any[]

  the byte array

### Const hexToNumber

- hexToNumber(value: any): any

- - Defined in utils/utils.ts:22

  #### Parameters

  - ##### value: any

  #### Returns any

### Const hexToNumberString

- hexToNumberString(hex: string): string

- - Defined in utils/utils.ts:309

  Converts value to it's decimal representation in string

  #### Parameters

  - ##### hex: string

  #### Returns string

### Const hexToUtf8

- hexToUtf8(hexStr: string): string

- - Defined in utils/utils.ts:256

  Should be called to get utf8 from it's hex representation

  #### Parameters

  - ##### hexStr: string

  #### Returns string

### Const inputAddressFormatter

- inputAddressFormatter(address: string): string

- - Defined in helper/formatters.ts:12

  #### Parameters

  - ##### address: string

  #### Returns string

### Const inputAddressesFormatter

- inputAddressesFormatter(addresses: any): number[][]

- - Defined in helper/formatters.ts:24

  #### Parameters

  - ##### addresses: any

  #### Returns number[][]

### Const inputContractCallFormatter

- inputContractCallFormatter(options: any): object

- - Defined in helper/formatters.ts:4

  #### Parameters

  - ##### options: any

  #### Returns object

  - ##### action: any

  - ##### contract_address: any

  - ##### params: string

### Const inputHashFormatter

- inputHashFormatter(hash: any): number[]

- - Defined in helper/formatters.ts:30

  #### Parameters

  - ##### hash: any

  #### Returns number[]

### Const inputPlaceholderFormatter

- inputPlaceholderFormatter(arg: any): any

- - Defined in helper/formatters.ts:34

  #### Parameters

  - ##### arg: any

  #### Returns any

### Const isAddress

- isAddress(address: string): boolean

- - Defined in utils/utils.ts:115

  Checks if the given string is an address

  #### Parameters

  - ##### address: string

    the given HEX address

  #### Returns boolean

### Const isContractAddress

- isContractAddress(address: string): boolean

- - Defined in utils/utils.ts:137

  Checks if the given string is an contract address

  #### Parameters

  - ##### address: string

    the given HEX address

  #### Returns boolean

### Const isHex

- isHex(hex: string | number): boolean

- - Defined in utils/utils.ts:184

  Check if string is HEX

  #### Parameters

  - ##### hex: string | number

    to be checked

  #### Returns boolean

### Const isHexStrict

- isHexStrict(hex: string | number | Buffer): boolean

- - Defined in utils/utils.ts:79

  Check if string is HEX, requires a 0x in front

  #### Parameters

  - ##### hex: string | number | Buffer

    to be checked

  #### Returns boolean

### Const keccak256

- keccak256(bits: string | number | any[] | Buffer): string

- - Defined in helper/hash.ts:4

  #### Parameters

  - ##### bits: string | number | any[] | Buffer

  #### Returns string

### Const keccak512

- keccak512(bits: string | number | any[] | Buffer): string

- - Defined in helper/hash.ts:11

  #### Parameters

  - ##### bits: string | number | any[] | Buffer

  #### Returns string

### Const length

- length(bytes: string): number
- length(len: number, add: number): string

- - Defined in helper/bytes.ts:16

  Get the length of bytes

  #### Parameters

  - ##### bytes: string

  #### Returns number

- - Defined in helper/rlp.ts:19

  Get the length of bytes

  #### Parameters

  - ##### len: number

  - ##### add: number

  #### Returns string

### Const makeSigner

- makeSigner(addToV: number): (Anonymous function)

- - Defined in helper/account.ts:136

  Make a signer method

  #### Parameters

  - ##### addToV: number

    A value add to v

  #### Returns (Anonymous function)

  A signer method

### Const noop

- noop(...__: any[]): any

- - Defined in utils/utils.ts:20

  Do nothing

  #### Parameters

  - ##### Rest ...__: any[]

  #### Returns any

### Const numberToHex

- numberToHex(value: string | number | BN): string

- - Defined in utils/utils.ts:198

  Converts value to it's hex representation

  #### Parameters

  - ##### value: string | number | BN

  #### Returns string

### Const outputBalanceFormatter

- outputBalanceFormatter(output: any): string

- - Defined in helper/formatters.ts:42

  #### Parameters

  - ##### output: any

  #### Returns string

### Const outputContractDetailFormatter

- outputContractDetailFormatter(output: any): ContractOutput

- - Defined in helper/formatters.ts:48

  #### Parameters

  - ##### output: any

  #### Returns ContractOutput

### Const outputNonceFormatter

- outputNonceFormatter(output: any): string

- - Defined in helper/formatters.ts:46

  #### Parameters

  - ##### output: any

  #### Returns string

### Const pad

- pad(len: number, bytes: string): string

- - Defined in helper/bytes.ts:55

  Fill the left of Bytes with a specific number of zeros

  #### Parameters

  - ##### len: number

  - ##### bytes: string

  #### Returns string

### Const padEven

- padEven(str: string): string

- - Defined in helper/rlp.ts:13

  #### Parameters

  - ##### str: string

  #### Returns string

### Const padRight

- padRight(len: number, hex: string): string

- - Defined in helper/bytes.ts:64

  Fill the right of Bytes with a specific number of zeros

  #### Parameters

  - ##### len: number

  - ##### hex: string

  #### Returns string

### Const parseFromHex

- parseFromHex(bits: string | number | any[] | Buffer): any[] | string | Buffer

- - Defined in helper/hash.ts:18

  #### Parameters

  - ##### bits: string | number | any[] | Buffer

  #### Returns any[] | string | Buffer

### Const parseHex

- parseHex(hex: string): DecodeResultInterface

- - Defined in helper/rlp.ts:71

  #### Parameters

  - ##### hex: string

  #### Returns DecodeResultInterface

### Const parseLength

- parseLength(hex: string): number

- - Defined in helper/rlp.ts:53

  #### Parameters

  - ##### hex: string

  #### Returns number

### Const parseList

- parseList(hex: string): DecodeResultInterface

- - Defined in helper/rlp.ts:79

  #### Parameters

  - ##### hex: string

  #### Returns DecodeResultInterface

### Const parseListLength

- parseListLength(hex: string): object

- - Defined in helper/rlp.ts:58

  #### Parameters

  - ##### hex: string

  #### Returns object

  - ##### len: number

  - ##### lengthHexLen: number

### Const parseTree

- parseTree(hex: string): DecodeResultInterface

- - Defined in helper/rlp.ts:95

  #### Parameters

  - ##### hex: string

  #### Returns DecodeResultInterface

### Const privateToPublicKey

- privateToPublicKey(privateKey: string, compress?: boolean): string

- - Defined in helper/account.ts:88

  Returns the public key of a given private key

  #### Parameters

  - ##### privateKey: string

  - ##### Default value compress: boolean = false

    Return the compressed public key or uncompressed public key, default false

  #### Returns string

### Const recover

- recover(hash: string, signature: string): string

- - Defined in helper/account.ts:165

  Recover an address from signature

  #### Parameters

  - ##### hash: string

  - ##### signature: string

  #### Returns string

### Const reverse

- reverse(bytes: string): string

- - Defined in helper/bytes.ts:41

  Reverse the specified bytes

  #### Parameters

  - ##### bytes: string

  #### Returns string

### Const rlpSignedTx

- rlpSignedTx(transactionResult: TransactionResult): string

- - Defined in helper/transaction.ts:50

  #### Parameters

  - ##### transactionResult: TransactionResult

  #### Returns string

### Const rlpTx

- rlpTx(transactionInput: TransactionInput): string

- - Defined in helper/transaction.ts:33

  #### Parameters

  - ##### transactionInput: TransactionInput

  #### Returns string

### Const sha3

- sha3(value: string | number | Buffer): string

- - Defined in utils/utils.ts:58

  Hashes values to a sha3 hash using keccak 256

  To hash a HEX string the hex must have 0x in front.

  #### Parameters

  - ##### value: string | number | Buffer

  #### Returns string

  the sha3 string

### Const signTransaction

- signTransaction(transactionData: TransactionData, privateKey: string, chainId?: string): string[]

- - Defined in helper/transaction.ts:15

  sign transaction()

  #### Parameters

  - ##### transactionData: TransactionData

  - ##### privateKey: string

  - ##### Default value chainId: string = "0x01"

  #### Returns string[]

  The signature

### Const slice

- slice(start: number, end: number, bytes: string): string

- - Defined in helper/bytes.ts:33

  Get the specified length of bytes from the specified bytes

  #### Parameters

  - ##### start: number

  - ##### end: number

  - ##### bytes: string

  #### Returns string

### Const toArray

- toArray(bytes: string): number[]

- - Defined in helper/bytes.ts:72

  Transfrom bytes to bytes string array

  #### Parameters

  - ##### bytes: string

  #### Returns number[]

### Const toAscii

- toAscii(bytes: string): string

- - Defined in helper/bytes.ts:153

  Return ASCII string from bytes string

  #### Parameters

  - ##### bytes: string

  #### Returns string

### Const toBN

- toBN(num: number | string | BN): BN
- toBN(str: string): BN

- - Defined in utils/utils.ts:39

  Takes an input and transforms it into an BN

  #### Parameters

  - ##### num: number | string | BN

  #### Returns BN

  BN

- - Defined in helper/nat.ts:6

  Takes an input and transforms it into an BN

  #### Parameters

  - ##### str: string

  #### Returns BN

  BN

### Const toChecksum

- toChecksum(address: string): string

- - Defined in helper/account.ts:29

  Transfrom address to check sum address

  #### Parameters

  - ##### address: string

  #### Returns string

  Check sum address

### Const toChecksumAddress

- toChecksumAddress(address: string): string

- - Defined in utils/index.ts:78

  #### Parameters

  - ##### address: string

  #### Returns string

### Const toNat

- toNat(bn: string): string

- - Defined in helper/bytes.ts:130

  #### Parameters

  - ##### bn: string

  #### Returns string

### Const toNumber

- toNumber(bytes: string): number
- toNumber(a: string): number

- - Defined in helper/bytes.ts:113

  return bytes number from bytes string

  #### Parameters

  - ##### bytes: string

  #### Returns number

- - Defined in helper/nat.ts:27

  return bytes number from bytes string

  #### Parameters

  - ##### a: string

  #### Returns number

### Const toString

- toString(bytes: string): string
- toString(a: string): string

- - Defined in helper/bytes.ts:178

  Return string from bytes string

  #### Parameters

  - ##### bytes: string

  #### Returns string

- - Defined in helper/nat.ts:18

  Return string from bytes string

  #### Parameters

  - ##### a: string

  #### Returns string

### Const toUint256

- toUint256(a: string): string

- - Defined in helper/nat.ts:29

  #### Parameters

  - ##### a: string

  #### Returns string

### Const toUint8Array

- toUint8Array(bytes: string): Uint8Array

- - Defined in helper/bytes.ts:90

  Return Uint8Array from bytes string

  #### Parameters

  - ##### bytes: string

  #### Returns Uint8Array

### Const toUnit

- toUnit(num: string | number | BN, unitType?: string): string

- - Defined in utils/index.ts:129

  #### Parameters

  - ##### num: string | number | BN

  - ##### Optional unitType: string

  #### Returns string

### Const uint

- uint(num: number): string

- - Defined in helper/rlp.ts:17

  #### Parameters

  - ##### num: number

  #### Returns string

### Const utf8ToHex

- utf8ToHex(str: string): string

- - Defined in utils/utils.ts:225

  Should be called to get hex representation (prefixed by 0x) of utf8 string

  #### Parameters

  - ##### str: string

  #### Returns string

  hex representation of input string

## Object literals

### Const provider

provider: object = new Provider('http://localhost:8888')

- Defined in core/index.spec.ts:3
- Defined in cs/contract/contract.spec.ts:4

### connected

connected: boolean = true

- Defined in core/index.spec.ts:6

### headers

headers: object[] = [{name: 'name',value: 'value'}]

- Defined in core/index.spec.ts:7

### host

host: string = "hos"

- Defined in core/index.spec.ts:4

### timeout

timeout: number = 1000

- Defined in core/index.spec.ts:5

### Const transactionResult

transactionResult: object

- Defined in cs/transaction/index.spec.ts:7

### txData

txData: object

- Defined in cs/transaction/index.spec.ts:8

### extraData

extraData: string = ""

- Defined in cs/transaction/index.spec.ts:15

### fee

fee: string = "10"

- Defined in cs/transaction/index.spec.ts:14

### hashLock

hashLock: null = null

- Defined in cs/transaction/index.spec.ts:11

### nonce

nonce: string = "0x0a"

- Defined in cs/transaction/index.spec.ts:9

### timeLock

timeLock: number = 0

- Defined in cs/transaction/index.spec.ts:12

### to

to: string = "0x00000000000000000000000121321432423534534534"

- Defined in cs/transaction/index.spec.ts:10

### value

value: string = "10000"

- Defined in cs/transaction/index.spec.ts:13

### witness

witness: object

- Defined in cs/transaction/index.spec.ts:17

### hashKey

hashKey: string = "0x"

- Defined in cs/transaction/index.spec.ts:21

### r

r: string = "0xf1bd5e6ffe6d3d1b78f7dc58a5e922229a5eba863e8d2dfa8e2e4df52837d2e4"

- Defined in cs/transaction/index.spec.ts:18

### s

s: string = "0x245a507467fb8e02001e61bb888b713c9cff16d3f2b798d62f5228f58eef961e"

- Defined in cs/transaction/index.spec.ts:19

### v

v: string = "0x38"

- Defined in cs/transaction/index.spec.ts:20

### Const transactionResult2

transactionResult2: object

- Defined in cs/transaction/index.spec.ts:25

### txData

txData: object

- Defined in cs/transaction/index.spec.ts:26

### extraData

extraData: string = "0x0000970e8128ab834e8eac17ab8e3812f010678cf791"

- Defined in cs/transaction/index.spec.ts:34

### fee

fee: string = "100"

- Defined in cs/transaction/index.spec.ts:33

### hashLock

hashLock: string = "0x64e604787cbf194841e7b68d7cd28786f6c9a0a3ab9f8b0a0e87cb4387ab0107"

- Defined in cs/transaction/index.spec.ts:29

### nonce

nonce: string = "0x1"

- Defined in cs/transaction/index.spec.ts:27

### timeLock

timeLock: number = 34564

- Defined in cs/transaction/index.spec.ts:31

### to

to: string = "0x00014059a38f1e42bd9a415f4578cd6f347112951d8d"

- Defined in cs/transaction/index.spec.ts:28

### value

value: string = "10000"

- Defined in cs/transaction/index.spec.ts:32

### witness

witness: object

- Defined in cs/transaction/index.spec.ts:36

### hashKey

hashKey: string = "0x"

- Defined in cs/transaction/index.spec.ts:40

### r

r: string = "0x1c2b9a65ba8bb0d5bd7b07655a909ecd2b17ff6c1a88c0a25051d155219457bf"

- Defined in cs/transaction/index.spec.ts:37

### s

s: string = "0x5cbbc90b74bb7e0a3f6d80df57674fb60d4a6325a30fb031ab33f03f463fa3a9"

- Defined in cs/transaction/index.spec.ts:38

### v

v: string = "0x3c"

- Defined in cs/transaction/index.spec.ts:39

### Const unitMap

unitMap: object

- Defined in utils/index.ts:103

### csk

csk: string = "100000000"

- Defined in utils/index.ts:108

### millions

millions: string = "1000000"

- Defined in utils/index.ts:107

### null

null: string = "0"

- Defined in utils/index.ts:104

### thousands

thousands: string = "1000"

- Defined in utils/index.ts:106

### units

units: string = "1"

- Defined in utils/index.ts:105

Generated using TypeDoc